note
	description: "Summary description for {EL_REFLECTION_MANAGER}."

	author: "Finnian Reilly"
	copyright: "Copyright (c) 2001-2017 Finnian Reilly"
	contact: "finnian at eiffel hyphen loop dot com"

	license: "MIT license (See: en.wikipedia.org/wiki/MIT_License)"
	date: "2017-12-23 7:08:02 GMT (Saturday 23rd December 2017)"
	revision: "2"

class
	EL_REFLECTION_MANAGER

inherit
	EL_REFLECTOR_CONSTANTS

	EL_MODULE_EIFFEL

create
	make

feature {NONE} -- Initialization

	make
		do
			create default_values_by_type_id.make_equal (3)
		end

feature -- Element change

	register (a_type: TYPE [EL_MAKEABLE_FROM_STRING])
		do
			if not default_values_by_type_id.has_key (a_type.type_id) then
				if attached {EL_MAKEABLE_FROM_STRING} Eiffel.new_instance_of (a_type.type_id) as makeable then
					makeable.make_default
					register_object (makeable)
				end
			end
		end

	register_object (object: EL_MAKEABLE_FROM_STRING)
			-- register a new object makeable from a string for use in classes inheriting `EL_REFLECTIVE'
			-- Use this routine if register causes an invariant violation
		do
			default_values_by_type_id.put (object, object.generating_type.type_id)
		end

feature {EL_REFLECTED_REFERENCE} -- Access

	default_values_by_type_id: HASH_TABLE [ANY, INTEGER_32]

end


