note
	description: "Summary description for {EL_REFLECTED_DATE_TIME}."

	author: "Finnian Reilly"
	copyright: "Copyright (c) 2001-2017 Finnian Reilly"
	contact: "finnian at eiffel hyphen loop dot com"

	license: "MIT license (See: en.wikipedia.org/wiki/MIT_License)"
	date: "2017-12-22 13:47:08 GMT (Friday 22nd December 2017)"
	revision: "2"

class
	EL_REFLECTED_DATE_TIME

inherit
	EL_REFLECTED_MAKEABLE_FROM_STRING_8
		redefine
			default_value, set_from_readable, write
		end

create
	make

feature -- Basic operations

	set_from_readable (a_object: EL_REFLECTIVE; readable: EL_MEMORY_READER_WRITER)
		local
			new_date_time: EL_DATE_TIME; date_time: DATE_TIME
		do
			if attached {EL_DATE_TIME} default_value as l_date_time then
				new_date_time := l_date_time.twin
				date_time := readable.read_date_time
				new_date_time.set_date (date_time.date)
				new_date_time.set_time (date_time.time)
				set (a_object, date_time)
			end
		end

	write (a_object: EL_REFLECTIVELY_SETTABLE; writeable: EL_MEMORY_READER_WRITER)
		do
			writeable.write_date_time (value (a_object))
		end

feature {NONE} -- Internal attributes

	default_value: detachable EL_DATE_TIME

end
