note
	description: "Summary description for {EL_ZSTRING_SETTABLE_REFERENCE}."

	author: "Finnian Reilly"
	copyright: "Copyright (c) 2001-2017 Finnian Reilly"
	contact: "finnian at eiffel hyphen loop dot com"

	license: "MIT license (See: en.wikipedia.org/wiki/MIT_License)"
	date: "2017-12-23 7:06:04 GMT (Saturday 23rd December 2017)"
	revision: "3"

class
	EL_REFLECTED_ZSTRING

inherit
	EL_REFLECTED_STRING
		redefine
			field_value, set_from_string, set_from_readable, to_string, write, default_value
		end

create
	make

feature -- Access

	to_string (a_object: EL_REFLECTIVE): ZSTRING
		do
			Result := value (a_object)
		end

feature -- Basic operations

	set_from_string (a_object: EL_REFLECTIVE; string: READABLE_STRING_GENERAL)
		do
			if attached {ZSTRING} string as z_str then
				set (a_object, z_str)
			else
				set (a_object, create {ZSTRING}.make_from_general (string))
			end
		end

	set_from_readable (a_object: EL_REFLECTIVE; readable: EL_READABLE)
		do
			set (a_object, readable.read_string)
		end

	write (a_object: EL_REFLECTIVE; writer: EL_WRITEABLE)
		do
			writer.write_string (value (a_object))
		end

feature {NONE} -- Implementation

	field_value (a_index: INTEGER): ZSTRING
		do
			if attached {ZSTRING} Precursor (a_index) as z_str then
				Result := z_str
			else
				create Result.make_empty
			end
		end

	set_default
		do
			default_value := Empty_string
		end

feature {NONE} -- Internal attributes

	default_value: ZSTRING
end
